commit 865336eee5d12dbad156fc3494033259731d9e53
Author: Tomáš Šimandl <tomas.simandl@gmail.com>
Date:   Tue Aug 21 12:44:41 2018 +0200

    added test data for backend tests

diff --git a/test/config/test1a expected result.txt b/test/config/test1a expected result.txt
new file mode 100644
index 0000000..2d3d3fe
--- /dev/null
+++ b/test/config/test1a expected result.txt	
@@ -0,0 +1,5 @@
+Vertices - ids: 32, 9, 1, 2
+Edges 	- from: 1, to: 32, ids: 117
+	- from: 1, to: 9, ids: 10
+	- from: 2, to: 9, ids: 8
+	
\ No newline at end of file
diff --git a/test/config/test1a.json b/test/config/test1a.json
new file mode 100644
index 0000000..a0a049f
--- /dev/null
+++ b/test/config/test1a.json
@@ -0,0 +1,67 @@
+{
+  "defaultFilter": {
+    "vertexArchetypeFilter": {
+      "archetypes": [  ],
+      "matchType": "non_matching"
+    },
+
+    "edgeArchetypeFilter": {
+      "archetypes": [
+        {
+          "fromArchetypes": [ "Ticket" ],
+          "edgeArchetypes": [ "Assignment" ],
+          "toArchetypes": [ "Person" ]
+        }
+      ],
+      "matchType": "non_matching"
+    },
+
+    "vertexAttributeFilters": [
+      {
+        "archetype": "Ticket",
+        "attributeName": "Created",
+        "filter": {
+          "min": "2017-04-05 00:00:00",
+          "max": "2017-04-12 12:00:00",
+          "minInclusive": true,
+          "maxInclusive": true,
+          "matchType": "matching"
+        }
+      },
+      {
+        "archetype": "Ticket",
+        "attributeName": "Estimate",
+        "filter": {
+          "min": 1.0,
+          "max": 3.0,
+          "minInclusive": true,
+          "maxInclusive": false,
+          "matchType": "non_matching"
+        }
+      },
+      {
+        "archetype": "Person",
+        "attributeName": "Roles",
+        "filter": {
+          "values": [ "Team leader", "Developer" ],
+          "matchType": "any"
+        }
+      }
+    ],
+
+    "edgeAttributeFilters": [
+      {
+        "archetype": "Authorship",
+        "attributeName": "Relation",
+        "filter": {
+          "values": [ "created by" ],
+          "matchType": "none"
+        }
+      }
+    ]
+  },
+  
+  "defaultGroupArchetypes": [],
+  
+  "archetypeIcons": []
+}
diff --git a/test/config/test1b expected result.txt b/test/config/test1b expected result.txt
new file mode 100644
index 0000000..23a8797
--- /dev/null
+++ b/test/config/test1b expected result.txt	
@@ -0,0 +1,4 @@
+Vertices - ids: 2, 9, 18
+Edges 	- from: 9, to: 2, ids: 9
+	- from: 18, to: 2, ids: 86
+	
\ No newline at end of file
diff --git a/test/config/test1b.json b/test/config/test1b.json
new file mode 100644
index 0000000..d983464
--- /dev/null
+++ b/test/config/test1b.json
@@ -0,0 +1,38 @@
+{
+  "defaultFilter": {
+    "vertexArchetypeFilter": {
+      "archetypes": [ "Person", "Ticket" ],
+      "matchType": "matching"
+    },
+
+    "edgeArchetypeFilter": {
+      "archetypes": [
+        {
+          "fromArchetypes": [ "Ticket" ],
+          "edgeArchetypes": [ "Authorship", "Modification" ],
+          "toArchetypes": [ "Person" ]
+        }
+      ],
+      "matchType": "matching"
+    },
+
+    "vertexAttributeFilters": [
+      {
+        "archetype": "Person",
+        "attributeName": "Role classes",
+        "filter": {
+          "values": [ "DEVELOPER", "PROJECTMANAGER" ],
+          "matchType": "exact_match"
+        }
+      }
+    ],
+
+    "edgeAttributeFilters": [
+      
+    ]
+  },
+  
+  "defaultGroupArchetypes": [],
+  
+  "archetypeIcons": []
+}
diff --git a/test/config/test1c expected result.txt b/test/config/test1c expected result.txt
new file mode 100644
index 0000000..8705bc4
--- /dev/null
+++ b/test/config/test1c expected result.txt	
@@ -0,0 +1,4 @@
+Vertices - ids: 2, 18, 32
+Edges 	- from: 2, to: 18, ids: 79
+	- from: 18, to: 2, ids: 86
+	
\ No newline at end of file
diff --git a/test/config/test1c.json b/test/config/test1c.json
new file mode 100644
index 0000000..845bc2e
--- /dev/null
+++ b/test/config/test1c.json
@@ -0,0 +1,45 @@
+{
+  "defaultFilter": {
+    "vertexArchetypeFilter": {
+      "archetypes": [ ],
+      "matchType": "non_matching"
+    },
+
+    "edgeArchetypeFilter": {
+      "archetypes": [
+        
+      ],
+      "matchType": "non_matching"
+    },
+
+    "vertexAttributeFilters": [
+      {
+        "archetype": "Ticket",
+        "attributeName": "Start",
+        "filter": {
+          "min": "2017-04-12 00:00:00",
+          "max": "2017-04-19 00:00:00",
+          "minInclusive": true,
+          "maxInclusive": false,
+          "matchType": "non_matching"
+        }
+      },
+      {
+        "archetype": "Person",
+        "attributeName": "Name",
+        "filter": {
+          "value": "Petr Mayr",
+          "matchType": "exact_match"
+        }
+      }
+    ],
+
+    "edgeAttributeFilters": [
+      
+    ]
+  },
+  
+  "defaultGroupArchetypes": [],
+  
+  "archetypeIcons": []
+}
diff --git a/test/config/test1d expected result.txt b/test/config/test1d expected result.txt
new file mode 100644
index 0000000..2a2d710
--- /dev/null
+++ b/test/config/test1d expected result.txt	
@@ -0,0 +1,4 @@
+Vertices - ids: 1, 9, 32
+Edges 	- from: 1, to: 9, ids: 10
+	- from: 1, to: 32, ids: 117
+	
\ No newline at end of file
diff --git a/test/config/test1d.json b/test/config/test1d.json
new file mode 100644
index 0000000..9a8aae3
--- /dev/null
+++ b/test/config/test1d.json
@@ -0,0 +1,54 @@
+{
+  "defaultFilter": {
+    "vertexArchetypeFilter": {
+      "archetypes": [ "Person", "Ticket", "Change" ],
+      "matchType": "matching"
+    },
+
+    "edgeArchetypeFilter": {
+      "archetypes": [
+        {
+          "fromArchetypes": [ "Person" ],
+          "edgeArchetypes": [ "Authorship" ],
+          "toArchetypes": [ "Change" ]
+        },
+        {
+          "fromArchetypes": [ "Person" ],
+          "edgeArchetypes": [ "Assignment" ],
+          "toArchetypes": [ "Ticket" ]
+        }
+      ],
+      "matchType": "matching"
+    },
+
+    "vertexAttributeFilters": [
+      {
+        "archetype": "Ticket",
+        "attributeName": "Spent",
+        "filter": {
+          "min": 1.0,
+          "max": 2.0,
+          "minInclusive": false,
+          "maxInclusive": true,
+          "matchType": "matching"
+        }
+      },
+      {
+        "archetype": "Person",
+        "attributeName": "Name",
+        "filter": {
+          "value": "Petr Mayr",
+          "matchType": "exact_mismatch"
+        }
+      }
+    ],
+
+    "edgeAttributeFilters": [
+      
+    ]
+  },
+  
+  "defaultGroupArchetypes": [],
+  
+  "archetypeIcons": []
+}
diff --git a/test/config/test1e expected result.txt b/test/config/test1e expected result.txt
new file mode 100644
index 0000000..4a1ce14
--- /dev/null
+++ b/test/config/test1e expected result.txt	
@@ -0,0 +1,4 @@
+Vertices - ids: 1, 32, 9
+Edges 	- from: 9, to: 1, ids: 11
+	- from: 1, to: 32, ids: 117
+	
\ No newline at end of file
diff --git a/test/config/test1e.json b/test/config/test1e.json
new file mode 100644
index 0000000..4b4da91
--- /dev/null
+++ b/test/config/test1e.json
@@ -0,0 +1,49 @@
+{
+  "defaultFilter": {
+    "vertexArchetypeFilter": {
+      "archetypes": [ ],
+      "matchType": "non_matching"
+    },
+
+    "edgeArchetypeFilter": {
+      "archetypes": [
+        
+      ],
+      "matchType": "non_matching"
+    },
+
+    "vertexAttributeFilters": [
+      {
+        "archetype": "Person",
+        "attributeName": "Name",
+        "filter": {
+          "value": "Jan",
+          "matchType": "containing"
+        }
+      },
+      {
+        "archetype": "Ticket",
+        "attributeName": "Description",
+        "filter": {
+          "value": "css",
+          "matchType": "non_containing"
+        }
+      }
+    ],
+
+    "edgeAttributeFilters": [
+      {
+        "archetype": "Assignment",
+        "attributeName": "Relation",
+        "filter": {
+          "values": [ "is assigned to" ],
+          "matchType": "any"
+        }
+      }
+    ]
+  },
+  
+  "defaultGroupArchetypes": [],
+  
+  "archetypeIcons": []
+}
diff --git a/test/config/test1f expected result.txt b/test/config/test1f expected result.txt
new file mode 100644
index 0000000..46b61c5
--- /dev/null
+++ b/test/config/test1f expected result.txt	
@@ -0,0 +1,3 @@
+Vertices - ids: 1, 2, 18
+Edges 	- from: 18, to: 2, ids: 86
+	
\ No newline at end of file
diff --git a/test/config/test1f.json b/test/config/test1f.json
new file mode 100644
index 0000000..2f71156
--- /dev/null
+++ b/test/config/test1f.json
@@ -0,0 +1,48 @@
+{
+  "defaultFilter": {
+    "vertexArchetypeFilter": {
+      "archetypes": [ "Person", "Ticket" ],
+      "matchType": "matching"
+    },
+
+    "edgeArchetypeFilter": {
+      "archetypes": [
+        {
+          "fromArchetypes": [ "Person" ],
+          "edgeArchetypes": [ "Modification" ],
+          "toArchetypes": [ "Ticket" ]
+        },
+        {
+          "fromArchetypes": [ "Person" ],
+          "edgeArchetypes": [ "Modification" ],
+          "toArchetypes": [ "Change" ]
+        },
+        {
+          "fromArchetypes": [ "Change" ],
+          "edgeArchetypes": [ "Modification" ],
+          "toArchetypes": [ "Person" ]
+        }
+      ],
+      "matchType": "non_matching"
+    },
+
+    "vertexAttributeFilters": [
+      {
+        "archetype": "Ticket",
+        "attributeName": "Description",
+        "filter": {
+          "value": ".*css.*",
+          "matchType": "regular_expression"
+        }
+      }
+    ],
+
+    "edgeAttributeFilters": [
+      
+    ]
+  },
+  
+  "defaultGroupArchetypes": [],
+  
+  "archetypeIcons": []
+}
diff --git a/test/data/test1.json b/test/data/test1.json
new file mode 100644
index 0000000..5839a34
--- /dev/null
+++ b/test/data/test1.json
@@ -0,0 +1,483 @@
+{
+ "attributeTypes": [
+  {
+   "dataType": "string",
+   "name": "EID",
+   "text": "External ID"
+  },
+  {
+   "dataType": "string",
+   "name": "Name",
+   "text": ""
+  },
+  {
+   "dataType": "string",
+   "name": "Description",
+   "text": ""
+  },
+  {
+   "dataType": "string",
+   "name": "Comment",
+   "text": ""
+  },
+  {
+   "dataType": "string",
+   "name": "Message",
+   "text": "Commit message"
+  },
+  {
+   "dataType": "string",
+   "name": "Identities",
+   "text": "Logins, aliases, other names"
+  },
+  {
+   "dataType": "string",
+   "name": "Emails",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Roles",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Author",
+   "text": "Author's name"
+  },
+  {
+   "dataType": "date",
+   "name": "Created",
+   "text": "Creation date"
+  },
+  {
+   "dataType": "string",
+   "name": "URL",
+   "text": ""
+  },
+  {
+   "dataType": "number",
+   "name": "Number",
+   "text": "Ticket number in issue tracker"
+  },
+  {
+   "dataType": "enum",
+   "name": "Assignee",
+   "text": "Assignee's name"
+  },
+  {
+   "dataType": "enum",
+   "name": "Type",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Priority",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Severity",
+   "text": ""
+  },
+  {
+   "dataType": "date",
+   "name": "Start",
+   "text": "Start date"
+  },
+  {
+   "dataType": "date",
+   "name": "Due",
+   "text": "Due date"
+  },
+  {
+   "dataType": "enum",
+   "name": "Iteration",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Status",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Resolution",
+   "text": ""
+  },
+  {
+   "dataType": "number",
+   "name": "Estimate",
+   "text": "Estimated time"
+  },
+  {
+   "dataType": "number",
+   "name": "Spent",
+   "text": "Spent time"
+  },
+  {
+   "dataType": "number",
+   "name": "Progress",
+   "text": "% done"
+  },
+  {
+   "dataType": "enum",
+   "name": "Categories",
+   "text": ""
+  },
+  {
+   "dataType": "string",
+   "name": "Identifier",
+   "text": ""
+  },
+  {
+   "dataType": "date",
+   "name": "Committed",
+   "text": "Committed on date"
+  },
+  {
+   "dataType": "string",
+   "name": "Changes",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Branches",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Tags",
+   "text": "VCS tags"
+  },
+  {
+   "dataType": "enum",
+   "name": "MIME",
+   "text": "MIME type"
+  },
+  {
+   "dataType": "number",
+   "name": "Size",
+   "text": "in bytes"
+  },
+  {
+   "dataType": "enum",
+   "name": "Relation",
+   "text": "Relation type"
+  },
+  {
+   "dataType": "enum",
+   "name": "Role classes",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Role super classes",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Type class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Priority class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Priority super class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Severity class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Severity super class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Status class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Status super class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Resolution class",
+   "text": ""
+  },
+  {
+   "dataType": "enum",
+   "name": "Resolution super class",
+   "text": ""
+  }
+ ],
+ "vertexArchetypes": [
+  {
+   "name": "Person",
+   "text": ""
+  },
+  {
+   "name": "Ticket",
+   "text": ""
+  },
+  {
+   "name": "File",
+   "text": ""
+  },
+  {
+   "name": "Wiki",
+   "text": ""
+  },
+  {
+   "name": "Change",
+   "text": ""
+  },
+  {
+   "name": "Commit",
+   "text": ""
+  },
+  {
+   "name": "RepoFile",
+   "text": ""
+  }
+ ],
+ "edgeArchetypes": [
+  {
+   "name": "Authorship",
+   "text": ""
+  },
+  {
+   "name": "Assignment",
+   "text": ""
+  },
+  {
+   "name": "CommitParticipation",
+   "text": ""
+  },
+  {
+   "name": "ItemRelation",
+   "text": ""
+  },
+  {
+   "name": "Affection",
+   "text": ""
+  },
+  {
+   "name": "Commit",
+   "text": ""
+  },
+  {
+   "name": "Modification",
+   "text": ""
+  }
+ ],
+ "vertices": [
+  {
+   "archetype": 0,
+   "attributes": {
+    "33": ["DEVELOPER"],
+    "1": "Jan Albl",
+    "34": ["TEAMMEMBER"],
+    "5": [
+     "Jan Albl",
+     "alblj"
+    ],
+    "6": [
+     "Jan Albl",
+     "alblj@students.zcu.cz"
+    ],
+    "7": ["Developer"]
+   },
+   "id": 1,
+   "text": "",
+   "title": "Jan Albl"
+  },
+  {
+   "archetype": 0,
+   "attributes": {
+    "33": [
+     "DEVELOPER",
+     "PROJECTMANAGER"
+    ],
+    "1": "Petr Mayr",
+    "34": [
+     "TEAMMEMBER",
+     "MANAGEMENT"
+    ],
+    "5": [
+     "Petr Mayr",
+     "pmayr"
+    ],
+    "6": [
+     "Petr Mayr",
+     "pmayr@students.zcu.cz"
+    ],
+    "7": [
+     "Developer",
+     "Team leader"
+    ]
+   },
+   "id": 2,
+   "text": "",
+   "title": "Petr Mayr"
+  },
+  {
+   "archetype": 1,
+   "attributes": {
+    "22": "1.949999988079071",
+    "23": "100",
+    "24": ["implementace"],
+    "10": "https://students.kiv.zcu.cz:3443/issues/5515",
+    "11": "5515",
+    "12": ["Jan Albl"],
+    "13": ["Task"],
+    "35": ["TASK"],
+    "14": ["High"],
+    "36": ["HIGH"],
+    "37": ["HIGH"],
+    "15": ["unassigned"],
+    "38": ["HIGH"],
+    "16": "2017-04-12 00:00:00",
+    "39": ["UNASSIGNED"],
+    "17": "2017-04-19 00:00:00",
+    "18": ["DCI - 4. iterace"],
+    "19": ["Closed"],
+    "0": "5515",
+    "1": "Formátování porovnávaných xml",
+    "2": "Xml popisující definici příkazu databáze vrací neformátované (tj. celé na jednom řádku) a bylo by tedy vhodné ho před porovnáním přeformátovat. Lze na to použít třídu cz.aimtec.dci.util.XMLFormatter.",
+    "8": ["Petr Mayr"],
+    "9": "2017-04-11 12:42:26",
+    "40": ["DONE"],
+    "41": ["CLOSED"],
+    "20": ["unassigned"],
+    "42": ["UNASSIGNED"],
+    "43": ["UNASSIGNED"],
+    "21": "3.0"
+   },
+   "id": 9,
+   "text": "",
+   "title": "5515"
+  },
+  {
+    "archetype": 1,
+    "attributes": {
+      "22": "1.0",
+      "23": "100",
+      "24": [ "implementace" ],
+      "10": "https://students.kiv.zcu.cz:3443/issues/5658",
+      "11": "5658",
+      "12": [ "Petr Mayr" ],
+      "13": [ "Task" ],
+      "35": [ "TASK" ],
+      "14": [ "High" ],
+      "36": [ "HIGH" ],
+      "37": [ "HIGH" ],
+      "15": [ "unassigned" ],
+      "38": [ "HIGH" ],
+      "16": "2017-04-19 00:00:00",
+      "39": [ "UNASSIGNED" ],
+      "17": "2017-04-26 00:00:00",
+      "18": [ "DCI - 5. iterace" ],
+      "19": [ "Closed" ],
+      "0": "5658",
+      "1": "DCI konvence zdrojových kódů",
+      "2": "Jedna z konvencí v DCI říká, že každé jsp musí mít vlastní css. Bude tedy nutné vytvořit css pro jsp s porovnáním, obsah bude stejný jako css aktuálně použitého jsp (transDefCompareXP.css).",
+      "8": [ "Petr Mayr" ],
+      "9": "2017-04-19 17:46:21",
+      "40": [ "DONE" ],
+      "41": [ "CLOSED" ],
+      "20": [ "unassigned" ],
+      "42": [ "UNASSIGNED" ],
+      "43": [ "UNASSIGNED" ],
+      "21": "1.0"
+    },
+    "id": 18,
+    "text": "",
+    "title": "5658"
+  },
+  {
+   "archetype": 4,
+   "attributes": {
+    "0": "7846",
+    "1": "",
+    "3": "Už jen přidám commit a hotovo\n\nActivity: Implementation",
+    "26": "2017-04-21 11:09:49",
+    "27": "LOGTIME Titulek okna s porovnáním - spentTime: 0.0 -> 2.0\n",
+    "8": ["Jan Albl"],
+    "9": "2017-04-21 00:00:00",
+    "10": ""
+   },
+   "id": 32,
+   "text": "",
+   "title": "7846"
+  }
+ ],
+ "edges": [
+  {
+   "archetype": 0,
+   "from": 2,
+   "attributes": {"32": "is author of"},
+   "id": 8,
+   "to": 9,
+   "text": ""
+  },
+  {
+   "archetype": 0,
+   "from": 9,
+   "attributes": {"32": "created by"},
+   "id": 9,
+   "to": 2,
+   "text": ""
+  },
+  {
+   "archetype": 1,
+   "from": 1,
+   "attributes": {"32": "is responsible for"},
+   "id": 10,
+   "to": 9,
+   "text": ""
+  },
+  {
+   "archetype": 1,
+   "from": 9,
+   "attributes": {"32": "is assigned to"},
+   "id": 11,
+   "to": 1,
+   "text": ""
+  },
+  {
+   "archetype": 6,
+   "from": 2,
+   "attributes": {"32": "added"},
+   "id": 79,
+   "to": 18,
+   "text": ""
+  },
+  {
+   "archetype": 6,
+   "from": 18,
+   "attributes": {"32": "logtimeed by"},
+   "id": 86,
+   "to": 2,
+   "text": ""
+  },
+  {
+   "archetype": 0,
+   "from": 1,
+   "attributes": {"32": "is author of"},
+   "id": 117,
+   "to": 32,
+   "text": ""
+  }
+ ]
+}
\ No newline at end of file