commit 879c1752411fd0ff4001ff84910bd0f242d5e7d5
Author: Pavel Fidranský <fidransky@outlook.com>
Date:   Sun Feb 10 20:31:39 2019 +0100

    minor improvements

diff --git a/sources/imiger-core/src/main/webapp/css/components/sidebar.css b/sources/imiger-core/src/main/webapp/css/components/sidebar.css
index 49b4407..d2c05fd 100644
--- a/sources/imiger-core/src/main/webapp/css/components/sidebar.css
+++ b/sources/imiger-core/src/main/webapp/css/components/sidebar.css
@@ -4,6 +4,7 @@
 	flex-direction: column;
 	justify-content: space-between;
 	background-color: #f0f9ff;
+	box-shadow: 0 0 5px #7db9e8;
 }
 
 .sidebar .button {
@@ -20,6 +21,7 @@
 
 .sidebar .node-container {
 	position: relative;
+	min-height: 140px; /* just enough to display one node */
 	overflow-y: overlay;
 }
 
diff --git a/sources/imiger-core/src/main/webapp/js/components/groupVertexList.js b/sources/imiger-core/src/main/webapp/js/components/groupVertexList.js
index 7b87ae4..0556788 100644
--- a/sources/imiger-core/src/main/webapp/js/components/groupVertexList.js
+++ b/sources/imiger-core/src/main/webapp/js/components/groupVertexList.js
@@ -37,7 +37,7 @@ class GroupVertexList {
 
 		if (this.isRendered) {
 			this._rootElement.childNodes.forEach(child => {
-				if (child.getAttribute('data-id') === vertex.id) {
+				if (child.dataset.id === vertex.id) {
 					child.remove();
 				}
 			});
diff --git a/sources/imiger-core/src/main/webapp/js/components/navbar.js b/sources/imiger-core/src/main/webapp/js/components/navbar.js
index 3c06746..71deced 100644
--- a/sources/imiger-core/src/main/webapp/js/components/navbar.js
+++ b/sources/imiger-core/src/main/webapp/js/components/navbar.js
@@ -93,9 +93,9 @@ class Navbar {
 	}
 
 	_createSearchListItem() {
-		let searchInput = DOM.h('input', {
+		const searchInput = DOM.h('input', {
 			type: 'search',
-			placeholder: 'Search components...',
+			placeholder: 'Search nodes...',
 			class: 'search-text',
 			id: 'searchText',
 			title: 'search nodes [ctrl + f]',
@@ -112,7 +112,7 @@ class Navbar {
 			},
 		});
 
-		let searchButton = DOM.h('button', {
+		const searchButton = DOM.h('button', {
 			class: 'btn search',
 			id: 'searchButton',
 			onClick: () => {
@@ -126,7 +126,7 @@ class Navbar {
 			}),
 		]);
 
-		let searchCounter = DOM.h('span', {
+		const searchCounter = DOM.h('span', {
 			class: 'search-count',
 			id: 'searchCount',
 			title: 'Count of components found',
@@ -181,9 +181,7 @@ class Navbar {
 
 		function resetSearch() {
 			let nodeList = app.nodeList;
-			nodeList.forEach(node => {
-				node.isFound = false;
-			});
+			nodeList.filter(node => node.isFound === true).forEach(node => node.isFound = false);
 
 			searchInput.value = '';
 			searchCounter.innerText = 0;
diff --git a/sources/imiger-core/src/main/webapp/js/components/saveDiagramModalWindow.js b/sources/imiger-core/src/main/webapp/js/components/saveDiagramModalWindow.js
index 2f89863..d0463ab 100644
--- a/sources/imiger-core/src/main/webapp/js/components/saveDiagramModalWindow.js
+++ b/sources/imiger-core/src/main/webapp/js/components/saveDiagramModalWindow.js
@@ -58,7 +58,7 @@ class SaveDiagramModalWindow extends ModalWindow {
 					]),
 				]),
 			]),
-		])
+		]);
 		this._bodyElement.appendChild(this._form);
 
 		return this._rootElement;
diff --git a/sources/imiger-core/src/main/webapp/js/components/viewport.js b/sources/imiger-core/src/main/webapp/js/components/viewport.js
index 7b1131a..628331d 100644
--- a/sources/imiger-core/src/main/webapp/js/components/viewport.js
+++ b/sources/imiger-core/src/main/webapp/js/components/viewport.js
@@ -170,7 +170,7 @@ class Viewport {
 
 		// reusable definitions
 		this._definitions = DOM.s('defs', {}, [
-			// linear gradient
+			// linear gradient for nodes that are highlighted as both required and provided
 			DOM.s('linearGradient', {
 				id: 'node--highlighted-as-required-provided',
 			}, [
diff --git a/sources/imiger-core/src/main/webapp/js/uploadFilesApp.js b/sources/imiger-core/src/main/webapp/js/uploadFilesApp.js
index f005a05..7a6e670 100644
--- a/sources/imiger-core/src/main/webapp/js/uploadFilesApp.js
+++ b/sources/imiger-core/src/main/webapp/js/uploadFilesApp.js
@@ -151,8 +151,8 @@ class UploadFilesApp extends App {
 	 * Removes diagram from DB and reloads the page.
 	 */
 	async _removeDiagram() {
-		let diagramId = this.getAttribute('data-id');
-		let diagramName = this.getAttribute('data-name');
+		let diagramId = this.dataset.id;
+		let diagramName = this.dataset.name;
 
 		if (confirm('Do you really want to delete ' + diagramName + '?')) {
 			try {